
#include "Debug_RS232.h"


void RS232_Debug_Init (unsigned long Baudrate)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;


	//configure clock for USART
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
	//configure clock for GPIO
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);

	//configure AF
	GPIO_PinAFConfig( GPIOB, GPIO_PinSource6, GPIO_AF_0 );

	//configure ports, &GPIO_InitStructure);
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init( GPIOB, &GPIO_InitStructure );

	USART_StructInit( &USART_InitStructure );
	USART_InitStructure.USART_BaudRate = Baudrate;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Tx;
	USART_Init( USART1, &USART_InitStructure );

	/* Enable USART */
	USART_Cmd(USART1, ENABLE);
}

/* String output */
void UART_Send_String (const char* p){
	while(*p){
		uart_putchar(*p, NULL);
		p++;
	}
}

/* char output */
int uart_putchar (char c, FILE *stream)
{
	while (USART_GetFlagStatus( USART1, USART_FLAG_TXE) == RESET );			// Warte solange bis Zeichen gesendet wurde
	USART_SendData(USART1, (uint8_t)c);										//Ausgabe des Zeichens
	return (0);
}


void DatenAusgabe(unsigned int Daten)
{
	unsigned char c;
	/* Zehntausender */
	c = Daten/10000;
	uart_putchar((c+'0'),NULL);

	/* Tausender */
	Daten %= 10000;
	c = Daten/1000;
	uart_putchar((c+'0'),NULL);

	/* Hunderter */
	Daten %= 1000;
	c = Daten/100;
	uart_putchar((c+'0'),NULL);

	/* Zehner */
	Daten %= 100;
	c = Daten/10;
	uart_putchar((c+'0'),NULL);

	/* Einer */
	Daten %= 10;
	c = Daten;
	uart_putchar((c+'0'),NULL);
	uart_putchar('\n',NULL);
}
