
#include "main.h"
#include "Funktionen.h"


void Init_IOs ( void )
{
	// Enable Clock
	RCC_AHBPeriphClockCmd( RCC_AHBPeriph_GPIOB | RCC_AHBPeriph_GPIOA, ENABLE );

	// Create Initstructure
	GPIO_InitTypeDef GPIO_InitStructure;

	// Debug LED
	GPIO_StructInit( &GPIO_InitStructure );
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init( GPIOB, &GPIO_InitStructure );


	// Button
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init( GPIOB, &GPIO_InitStructure );

	// Control IOs for BLDC
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_10 | GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init( GPIOA, &GPIO_InitStructure );

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_11 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_OD;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_Level_3;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init( GPIOA, &GPIO_InitStructure );

}


void NextCommutation ( uint8_t Vektor  )
{
	switch ( Vektor ){
		case 1: L3_LOW_ENABLE();L2_FLOATING_ENABLE();L1_PWM_ENABLE();  break;
		case 2: L3_LOW_ENABLE();L1_FLOATING_ENABLE();L2_PWM_ENABLE();  break;
		case 3: L1_LOW_ENABLE();L3_FLOATING_ENABLE();L2_PWM_ENABLE();  break;
		case 4: L1_LOW_ENABLE();L2_FLOATING_ENABLE();L3_PWM_ENABLE();  break;
		case 5: L2_LOW_ENABLE();L1_FLOATING_ENABLE();L3_PWM_ENABLE();  break;
		case 6: L2_LOW_ENABLE();L3_FLOATING_ENABLE();L1_PWM_ENABLE();  break;
		default: POWERSTAGE_OFF();
	}

	Flags.ForcecommutationTimer = FORCECOMMUTATIONTIME;
}


uint32_t  Middle_Current ( uint32_t Current_Raw )
{
	uint32_t Buffer = 0;
	static uint32_t Data[CURRENT_MIDDLE];
	static uint32_t Index = 0xffffffff;

	if ( ++Index >= CURRENT_MIDDLE ) Index = 0;
	Data[Index] = Current_Raw ;

	for ( uint32_t i = 0; i < CURRENT_MIDDLE; i++ ){
		Buffer += Data[i];
	}
	Buffer /= CURRENT_MIDDLE;
	return Buffer;
}

