

#include <inttypes.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <stm32f0xx.h>

#define nop						 __asm volatile("nop");

#define L1_FLOATING_ENABLE()	 GPIOA->ODR &= ~GPIO_Pin_8; GPIOA->ODR |= GPIO_Pin_10 | GPIO_Pin_12;
#define L2_FLOATING_ENABLE()	 GPIOA->ODR &= ~GPIO_Pin_10; GPIOA->ODR |= GPIO_Pin_8 | GPIO_Pin_12 ;
#define L3_FLOATING_ENABLE()	 GPIOA->ODR &= ~GPIO_Pin_12; GPIOA->ODR |= GPIO_Pin_8 | GPIO_Pin_10 ;
#define POWERSTAGE_OFF()		 GPIOA->ODR &= ~ (GPIO_Pin_8 | GPIO_Pin_10 | GPIO_Pin_12);
#define PREPARE_ADJUST()		 GPIOA->ODR &= ~ (GPIO_Pin_9 | GPIO_Pin_11 | GPIO_Pin_15);  GPIOA->ODR |= (GPIO_Pin_8 | GPIO_Pin_10 | GPIO_Pin_12);
#define ADJUST()				 GPIOA->ODR |=  GPIO_Pin_9;


#define L1_PWM_ENABLE()			(GPIOA->ODR |= GPIO_Pin_9)
#define L2_PWM_ENABLE()			(GPIOA->ODR |= GPIO_Pin_11)
#define L3_PWM_ENABLE()			(GPIOA->ODR |= GPIO_Pin_15)

#define L1_LOW_ENABLE()			(GPIOA->ODR &= ~GPIO_Pin_9)
#define L2_LOW_ENABLE()			(GPIOA->ODR &= ~GPIO_Pin_11)
#define L3_LOW_ENABLE()			(GPIOA->ODR &= ~GPIO_Pin_15)




enum{
	RPM_SOLL_RAW = 0,
	BEMF1 = 1 ,
	BEMF3 = 2 ,
	BEMF2 = 3,
	U_DC = 4,
	I_DC = 5
};


enum{
	CURRENTLIMITTIME = 5000,
	FORCECOMMUTATIONTIME = 25,
	CURRENTLIMIT = 4000,
	UNDERVOLTAGE = 3000,
	OVERVOLTAGE = 4050,
	ON = 2,
	GET_POSITION = 1,
	OFF = 0,
	SYSTICK_IN_HZ = 1000,
	BAUDRATE = 9600,
	LOCKTIME = 50,
	NR_OF_VALUES = 6,
	DEBOUNCETIME = 500,
	NR_OF_RPM_MIDDLE = 16,
	SET_THRESHOLD = 2450,
	CURRENT_MIDDLE = 16,
	RUNUPTIME = 2000
};

struct Flags_s{
	uint8_t UsartDataOut;
	uint16_t Overcurrent;
	uint16_t Voltagerange;
	uint16_t ForcecommutationTimer;
	uint16_t RunUp;
};



extern volatile uint16_t DataBuffer[NR_OF_VALUES];
extern volatile struct Flags_s Flags;
extern volatile uint16_t Motorstate;
extern volatile uint8_t CommutationVektor;
extern volatile uint32_t Fluxintegral;
extern volatile uint16_t FluxThreshold;
extern volatile uint16_t rpm;
extern volatile uint16_t rpm_soll;
extern volatile uint32_t Dummy;
extern volatile uint32_t Temp[3];
